#import "ParticleToolsPrincipal.h"

#import "ParticleParticlePatch.h"
#import "ParticleScenePatch.h"
#import "ParticleRendererPatch.h"
#import "ParticleEmitterPatch.h"
#import "ParticleOperatorNumberRandomPatch.h"
#import "ParticleOperatorVectorRandomPatch.h"
#import "ParticleOperatorVectorImagePatch.h"
#import "ParticleForceGravityPatch.h"
#import "ParticleForceVortexPatch.h"
#import "ParticleForceExplosionPatch.h"
#import "ParticleForceWindPatch.h"
#import "ParticleForceDampingPatch.h"
#import "ParticleLooksColorTablePatch.h"
#import "ParticleRenderClassPatch.h"
#import "ParticleColliderPatch.h"

//#import "ParticleColliderKineme3DPatch.h"

@implementation ParticleToolsPlugin
+ (void)registerNodesWithManager:(GFNodeManager*)manager
{
	if( [manager isNodeRegisteredWithName:NSStringFromClass([ParticleScenePatch class])] == FALSE )
		[manager registerNodeWithClass:[ParticleScenePatch class]];
	if( [manager isNodeRegisteredWithName:NSStringFromClass([ParticleRendererPatch class])] == FALSE )
		[manager registerNodeWithClass:[ParticleRendererPatch class]];
	if( [manager isNodeRegisteredWithName:NSStringFromClass([ParticleEmitterPatch class])] == FALSE )
		[manager registerNodeWithClass:[ParticleEmitterPatch class]];

	if( [manager isNodeRegisteredWithName:NSStringFromClass([ParticleOperatorNumberRandomPatch class])] == FALSE )
		[manager registerNodeWithClass:[ParticleOperatorNumberRandomPatch class]];
	if( [manager isNodeRegisteredWithName:NSStringFromClass([ParticleOperatorVectorRandomPatch class])] == FALSE )
		[manager registerNodeWithClass:[ParticleOperatorVectorRandomPatch class]];
//	if( [manager isNodeRegisteredWithName:NSStringFromClass([ParticleOperatorVectorImagePatch class])] == FALSE )
//		[manager registerNodeWithClass:[ParticleOperatorVectorImagePatch class]];

	if( [manager isNodeRegisteredWithName:NSStringFromClass([ParticleForceGravityPatch class])] == FALSE )
		[manager registerNodeWithClass:[ParticleForceGravityPatch class]];
	if( [manager isNodeRegisteredWithName:NSStringFromClass([ParticleForceVortexPatch class])] == FALSE )
		[manager registerNodeWithClass:[ParticleForceVortexPatch class]];
	if( [manager isNodeRegisteredWithName:NSStringFromClass([ParticleForceExplosionPatch class])] == FALSE )
		[manager registerNodeWithClass:[ParticleForceExplosionPatch class]];
	if( [manager isNodeRegisteredWithName:NSStringFromClass([ParticleForceWindPatch class])] == FALSE )
		[manager registerNodeWithClass:[ParticleForceWindPatch class]];
	if( [manager isNodeRegisteredWithName:NSStringFromClass([ParticleForceDampingPatch class])] == FALSE )
		[manager registerNodeWithClass:[ParticleForceDampingPatch class]];

	if( [manager isNodeRegisteredWithName:NSStringFromClass([ParticleParticlePatch class])] == FALSE )
		[manager registerNodeWithClass:[ParticleParticlePatch class]];
	if( [manager isNodeRegisteredWithName:NSStringFromClass([ParticleLooksColorTablePatch class])] == FALSE )
		[manager registerNodeWithClass:[ParticleLooksColorTablePatch class]];
	if( [manager isNodeRegisteredWithName:NSStringFromClass([ParticleRenderClassPatch class])] == FALSE )
		[manager registerNodeWithClass:[ParticleRenderClassPatch class]];

	if( [manager isNodeRegisteredWithName:NSStringFromClass([ParticleColliderPatch class])] == FALSE )
		[manager registerNodeWithClass:[ParticleColliderPatch class]];
	
	/* KinemeCore framework hackery */
	/*if([[NSFileManager defaultManager] fileExistsAtPath:@"/Library/Frameworks/KinemeCore.framework"])
	{
		//NSLog(@"framework exists!");
		NSBundle *kinemeCore = [NSBundle bundleWithPath:@"/Library/Frameworks/KinemeCore.framework"];
		if([kinemeCore isLoaded] || [kinemeCore load])
		{
			if([NSBundle bundleForClass: NSClassFromString(@"Kineme3DObjectPort")])
			{
				NSLog(@"KinemeCore with Kineme3D loaded... you must be lucky alpha tester ;) ");
				if( [manager isNodeRegisteredWithName:NSStringFromClass([ParticleColliderKineme3DPatch class])] == FALSE )
					[manager registerNodeWithClass:[ParticleColliderKineme3DPatch class] identifier:NULL isPrivate: YES];
			}
		}
	}*/
}
@end
