/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of DIVA base library.
 *
 * Author(s): Jarmo Hiipakka and Tommi Ilmonen, 2000-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * DIVA - Digital Interactive Virtual Acoustics group 
 * Telecommunications Software and Multimedia Laboratory
 * Helsinki University of Technology
 * Finland
 *
 * http://www.tml.hut.fi/Research/DIVA/
 *
 * DIVA base library is licensed under GNU Lesser General Public
 * License (LGPL). The LGPL conditions can be found in file "LGPL"
 * that is distributed with this source package or obtained from the
 * GNU organization (www.gnu.org).
 * 
 */

#ifndef DI_TYPES_H
#define DI_TYPES_H

#ifndef WIN32
	#include <sys/types.h>

	#if defined(__sgi)
		extern "C" {
		/* Some SGI systems require this crap (compiler/header mismatch ??). */
		}
	#endif // __sgi

	#include <sys/types.h>

	typedef long long llong;
	typedef unsigned long long ullong;

	#if defined(__APPLE__) && defined(__MACH__)
		typedef unsigned long ulong;
	#endif
#else
	//#include <windows.h>

	#include <unixstuff.h>
	typedef signed __int64 llong;
	typedef unsigned __int64 ullong;
	typedef unsigned int uint;
	typedef unsigned long ulong;
#endif	//WIN32

typedef unsigned char uchar;

#endif


