/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the DIVA IO library.
 *
 * Author(s): Jarmo Hiipakka and Tommi Ilmonen, 2000-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * DIVA - Digital Interactive Virtual Acoustics group 
 * Telecommunications Software and Multimedia Laboratory
 * Helsinki University of Technology
 * Finland
 *
 * http://www.tml.hut.fi/Research/DIVA/
 *
 * DIVA IO library is licensed under GNU Lesser General Public
 * License (LGPL). The LGPL conditions can be found in file "LGPL"
 * that is distributed with this source package or obtained from the
 * GNU organization (www.gnu.org).
 * 
 */

#ifndef DI_IMAGE_CONVERSION_H
#define DI_IMAGE_CONVERSION_H

class DI_Image;

/** Image conversion utilities. New format conversion functions will
    be written as needed. */

class DI_ImageConversion
{
public:
  static bool convert(const DI_Image * source, DI_Image * target);

  static void YUV411ToRGB(const DI_Image * source, DI_Image * target);
  static void YUV411ToGrayscale(const DI_Image * source, DI_Image * target);
  static void YUV420PToGrayscale(const DI_Image * source, DI_Image * target);
  static void YUV420ToGrayscale(const DI_Image * source, DI_Image * target);
  static void grayscaleToRGB(const DI_Image * source, DI_Image * target);
  static void RGBToGrayscale(const DI_Image * source, DI_Image * target);
};


#endif
