/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */


#ifndef MJ_LATENCY_GUI_H
#define MJ_LATENCY_GUI_H

#include <qwidget.h>

class QLabel;
class MJ_Slider;

/** A GUI for controlling latency. */

class MJ_LatengyGui : public QWidget
{
  Q_OBJECT
public:  
  MJ_LatengyGui(float minLat,
		float maxLat,
		QWidget      *parent = 0,
		const char   *name = 0);
  virtual ~MJ_LatengyGui();

public slots:

  void setMin(double);
  void setMax(double);

signals:

  void newConf(float, float);

protected:

  void updateTexts();

  void emitConf();

  MJ_Slider  *m_minSlider, *m_maxSlider;
  QLabel *m_minStr, *m_maxStr;
};

#endif
