/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */


#include <mj_list.h>

template<class TElem> 
void MJ_List<TElem>::sort()
{
  bool ad = this->autoDelete();
  this->setAutoDelete(false);
  
  QListIterator<TElem> iter(*this);

  TElem *tmp;
  MJ_List<TElem> sortList;

  while((tmp = iter.current())) {
    sortList.inSort(tmp);
    ++iter;
  }

  *this = sortList;

  this->setAutoDelete(ad);
}

template<class TElem> 
bool MJ_List<TElem>::resize(uint new_size)
{
  while(new_size > this->count()) {
    TElem *tmp = new TElem;
    if(!tmp) return false;
    this->append(tmp);
  }
  while (new_size < this->count()) {
    this->removeLast();
  }
  return true;
}
