/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#ifndef MJ_MODULE_DSP_TUI_DEFAULT_H
#define MJ_MODULE_DSP_TUI_DEFAULT_H

#include <mj_module_dsp_tui.h>

#include <mj_parameter.h>

enum MJ_TuiCommand {
  MJ_TUC_LOAD,
  MJ_TUC_PANIC,
  MJ_TUC_PARAM,
  MJ_TUC_UP,
  MJ_TUC_SAVE,
  MJ_TUC_SIZEOF
};

extern const char * MJ_tuiKeyWords[MJ_TUC_SIZEOF];

/** Default text-mode user interface. */
class MJ_ModuleDspTuiDefault : public MJ_ModuleDspTui
{
  Q_OBJECT
public:
  /** Constructor */
  MJ_ModuleDspTuiDefault(MJ_RtControl *parent,
			 MJ_ModuleDsp *m,
			 const char *name = 0);
  /** Desctructor */
  virtual ~MJ_ModuleDspTuiDefault();
  
protected:

  /** Gets one command from the user. Returns false if the user wants
      to exit this UI. */
  bool oneEvent();

  /** Write textual description of the module. */
  void describeModule();
  
  /** Handles one input message from the user. Return false if the
      user wants to exit this UI. */
  bool handleMessage();

  void getParam();

  void inputWarning(QCString &str);

  void save();
  void load();

  MJ_Parameters  m_parameters;

  static bool m_tuiDebug;
};

#endif
