/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#ifndef MJ_MULTI_INT_H
#define MJ_MULTI_INT_H

class  QTextStream;


/** A two-integer structure. */
struct MJ_2Int {
  ///
  int m_v[2];
} ;

/** Tests for equality. */
inline bool MJ_equals(const MJ_2Int &mi1, const MJ_2Int &mi2)
{
  return (mi1.m_v[0] == mi2.m_v[0]) &&(mi1.m_v[1] == mi2.m_v[1]);
}

/** A three-integer structure. */
struct MJ_3Int {
  ///
  int m_v[3];
};

/** Tests for equality. */
inline bool MJ_equals(const MJ_3Int &mi1, const MJ_3Int &mi2)
{
  return (mi1.m_v[0] == mi2.m_v[0]) && (mi1.m_v[1] == mi2.m_v[1]) &&
    (mi1.m_v[2] == mi2.m_v[2]);
}

void MJ_writeMultiInt(const int *data, unsigned count, QTextStream *);
void MJ_readMultiInt(int *data, unsigned count, QTextStream *);

#endif
