/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */
#ifndef MJ_MULTI_SAMPLE_H
#define MJ_MULTI_SAMPLE_H

#include <mj_config.h>

/** A two-sample structure. */
class MJ_DualSample {
public:
  
  void clear() { m_v[0] = m_v[1] = 0.0f; }

  MJ_Sample m_v[2];
};

/** A three-sample structure. */
typedef struct _MJ_TriSample {
  MJ_Sample m_v[3];
} MJ_TriSample;

/** A four-sample structure. */
typedef struct _MJ_QuadSample {
  MJ_Sample m_v[4];
} MJ_QuadSample;

#endif
