/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#ifndef MJ_MUTEX_H
#define MJ_MUTEX_H

#include <di_mutex.h>

typedef DI_Mutex MJ_Mutex;
typedef DI_MutexAuto MJ_MutexAuto;

/* Copy commands. 

inline void MJ_copy(float *r, const float &v, DI_Mutex *)
{
  *r = v;
}

inline void MJ_copy(double *r, const double v, DI_Mutex *m)
{
  if(!m) {
    *r = v;    
    return;
  }

  m->lock();
  *r = v;
  m->unlock();
}

inline void MJ_copy(short *r, const short &v, DI_Mutex *)
{
  *r = v;
}

inline void MJ_copy(int *r, const int &v, DI_Mutex *)
{
  *r = v;
}

inline void MJ_copy(unsigned *r, const unsigned &v, DI_Mutex *)
{
  *r = v;
}

inline void MJ_copy(long *r, const long &v, DI_Mutex *m)
{
  if(!m) {
    *r = v;    
    return;
  }

  m->lock();
  *r = v;
  m->unlock();
}

inline void MJ_copy(long long *r, const long long &v, DI_Mutex *m)
{
  if(!m) {
    *r = v;    
    return;
  }

  m->lock();
  *r = v;
  m->unlock();
}

#include <qstring.h>

inline void MJ_copy(QString *r, const QString *v, DI_Mutex *m)
{
  if(!m) {
    *r = v->copy();
    return;
  }

  m->lock();
  int s = v->length();
  m->unlock();
  
  r->setLength(s);
  
  m->lock();
  memcpy(& (r->ref(0)), & (((QString *) v)->ref(0)), s * sizeof(QChar));
  m->unlock();  
}

*/

#endif
