/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#ifndef MJ_SIGNAL_FRAME_GUI_H
#define MJ_SIGNAL_FRAME_GUI_H

#include <mj_gui_int.h> 
#include <mj_rt_control.h>

#include <qwidget.h>

class QComboBox;

/** A GUI to control frame size and master rate. */

class MJ_SignalFrameGui : public QWidget, public MJ_RtControl
{
  Q_OBJECT
public:
  MJ_SignalFrameGui(int samplingRate,
		    int frameSize,
		    int maxFrame,
		    MJ_RtControl *rtParent,
		    QWidget *parent = 0,
		    const char *name = 0);

  static int indexToRate(int);
  static int rateToIndex(int);

public slots:
  void selectRate(int);
  void setFrameSize(int);
  void getFrameSize(int *);

signals:

  void masterRate(int);
  void emitFrameSize(int);
  void emitGetFrameSize(int *);

protected:

  virtual void realTimeChange (bool nowRt);

  QComboBox *m_combo;
  MJ_GuiIntSlider m_is;
  int             m_maxFrame;
};

#endif
