/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#ifndef MJ_VALUE_H
#define MJ_VALUE_H

#include <qdom.h>

class MJ_HasValues;

class MJ_Value
{
public:
  
  MJ_Value(MJ_HasValues * host = 0,
	   const char * id = 0);

  MJ_Value(const MJ_Value & that);

  virtual ~MJ_Value();

  void setId(const QString & id) { m_id = id; }
  const QString & id() const { return m_id; }

  virtual QDomElement writeDom(QDomDocument &) = 0;
  virtual bool readDom(QDomElement &elem) = 0;

  inline MJ_Value & operator = (const MJ_Value & that)
  { m_id = that.m_id; return *this; }

protected:
  MJ_HasValues * m_host;
  QString m_id;
};

#endif
