/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#ifndef MJ_CONFIG_H
#define MJ_CONFIG_H

#include <di_endian.h>

// Version number:
#define MJ_VERSION_MAJOR 0
#define MJ_VERSION_MINOR 2
#define MJ_VERSION_SUBMINOR 7

// Is our sample float or double:
#ifndef MJ_SAMPLE_IS_FLOAT
#define MJ_SAMPLE_IS_FLOAT 1
#endif  // MJ_SAMPLE_IS_FLOAT

#if MJ_SAMPLE_IS_FLOAT == 1
typedef float MJ_Sample;
#else 
typedef double MJ_Sample;
#endif  // MJ_SAMPLE_IS_FLOAT == 1

// Debugging control
#define MJ_MEM_DEBUG 1
// #define MJ_NDEBUG 

#if defined(__sgi)
#if _COMPILER_VERSION >= 720
#define RESTRICT restrict
#else
#define RESTRICT
#endif // _COMPILER_VERSION >= 720
#endif // defined(__sgi)

#if defined(__i686__) || defined(__i586__) || defined(__i486__) 

#define __x86__

#endif

#endif
