/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */


#ifndef MJ_MESSAGE_ENUMS_H
#define MJ_MESSAGE_ENUMS_H

/** Mustajuures message types. 
    
    @see g_messageTypes MJ_Message
 */
enum MJ_MessageType {
  MJ_MSG_EMPTY,
  MJ_MSG_BOOL,
  // MJ_MSG_FLOAT,
  MJ_MSG_DOUBLE,
  MJ_MSG_INT,
  // MJ_MSG_LONG,
  MJ_MSG_STRING,
  MJ_MSG_STL_STRING,
  MJ_MSG_MIDI_EVENT,
  MJ_MSG_MULTI,
  MJ_MSG_SIZEOF
};

/** Character strings that correspond to the message types.
    
    @see MJ_MessageType
 */
extern const char *MJ_messageTypes[MJ_MSG_SIZEOF];


/** Short plaintext strings that correspond to the message types.
    
    @see MJ_MessageType
 */
extern const char *MJ_messageTypesShort[MJ_MSG_SIZEOF];


#endif
