#import "ParticleColliderKineme3DPatch.h"
#import "vee_opcode_collision.h"

@implementation ParticleColliderKineme3DPatch

- (id)attributes
{
	NSMutableDictionary *at=[[super attributes] mutableCopy];
	[at setObject:@"Kineme Particle Collider Kineme3D" forKey:@"name"];
	return at;
}


- (id)initWithIdentifier:(id)fp8
{
	//	NSLog(@"ParticleColliderPatch::initWithIdentifier");
	self=[super initWithIdentifier:fp8];
	if(self)
	{
		[inputUpdateVelocity setBooleanValue:NO];
		
		[inputBounce setDoubleValue:1.0];
		
		[inputDrag setDoubleValue:0.0];
	}
	return self;
}


- (BOOL)setup:(QCOpenGLContext *)context
{
	[super setup:context];
	
	//	NSLog(@"ParticleColliderPatch::setup");
	
	VEE_OpcodeCollision *oc=new VEE_OpcodeCollision();
	[_object setObject:oc];
	
	return YES;
}
- (void)cleanup:(QCOpenGLContext *)context
{
	[super cleanup:context];
	
	//	NSLog(@"ParticleColliderPatch::cleanup");
	// _object takes care of releasing our VEE_OpcodeCollision
}


- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	[super execute:context time:time arguments:arguments];
	
	//	NSLog(@"ParticleColliderPatch::execute");
	
	VEE_OpcodeCollision *oc=(VEE_OpcodeCollision *)[_object object];
	
	//if( [inputFaces wasUpdated] )
	Kineme3DObject *obj = [inputObject Kineme3DObjectValue];
	if(obj)
	{
		//		NSLog(@"ParticleColliderPatch::execute faces updated");
        oc->meshClear();
		//if( [inputFaces structureValue] )
		{
			//			NSLog(@"ParticleColliderPatch::execute faces is good %d",[[inputFaces structureValue] count]);
			int i, count;
			unsigned int *vertices;
			Kineme3DVector3 *vec;
			count = [obj faceCount];
			vertices = [obj getFaces];
			vec = [obj getVertices];
			//NSLog(@"adding %i faces", count);
			for(i = 0; i < count; ++i)
			{
				oc->meshAddTri(VEE_Vector3(vec[vertices[i*3+0]].x,
										   vec[vertices[i*3+0]].y,
										   vec[vertices[i*3+0]].z),
							   VEE_Vector3(vec[vertices[i*3+1]].x,
										   vec[vertices[i*3+1]].y,
										   vec[vertices[i*3+1]].z),
							   VEE_Vector3(vec[vertices[i*3+2]].x,
										   vec[vertices[i*3+2]].y,
										   vec[vertices[i*3+2]].z));
			}
			/*for(i=0;i< [[inputFaces structureValue] count] ;i+=9)
			{
				double x1 = [[[inputFaces structureValue] memberForKey:[NSString stringWithFormat:@"%d",i  ]] doubleValue];
				double y1 = [[[inputFaces structureValue] memberForKey:[NSString stringWithFormat:@"%d",i+1]] doubleValue];
				double z1 = [[[inputFaces structureValue] memberForKey:[NSString stringWithFormat:@"%d",i+2]] doubleValue];
				double x2 = [[[inputFaces structureValue] memberForKey:[NSString stringWithFormat:@"%d",i+3]] doubleValue];
				double y2 = [[[inputFaces structureValue] memberForKey:[NSString stringWithFormat:@"%d",i+4]] doubleValue];
				double z2 = [[[inputFaces structureValue] memberForKey:[NSString stringWithFormat:@"%d",i+5]] doubleValue];
				double x3 = [[[inputFaces structureValue] memberForKey:[NSString stringWithFormat:@"%d",i+6]] doubleValue];
				double y3 = [[[inputFaces structureValue] memberForKey:[NSString stringWithFormat:@"%d",i+7]] doubleValue];
				double z3 = [[[inputFaces structureValue] memberForKey:[NSString stringWithFormat:@"%d",i+8]] doubleValue];
				oc->meshAddTri(
							   VEE_Vector3(x1,y1,z1),
							   VEE_Vector3(x2,y2,z2),
							   VEE_Vector3(x3,y3,z3)
							   );
				//				NSLog(@"ParticleColliderPatch::execute faces addTri(%f,%f,%f,%f,%f,%f,%f,%f,%f)",x1,y1,z1,x2,y2,z2,x3,y3,z3);
			}*/
		}
        oc->meshCommit();
	}
	
	if( [inputBounce wasUpdated] )
        oc->setValueFloat("bounce", [inputBounce doubleValue]);
	if( [inputDrag wasUpdated] )
        oc->setValueFloat("drag", [inputDrag doubleValue]);
	
	return YES;
}

@end
