#import "ParticleColliderPatch.h"
#import "vee_opcode_collision.h"

@implementation ParticleColliderPatch

- (id)attributes
{
	NSMutableDictionary *at=[[super attributes] mutableCopy];
	[at setObject:@"Kineme Particle Collider" forKey:@"name"];
	return at;
}


- (id)initWithIdentifier:(id)fp8
{
//	NSLog(@"ParticleColliderPatch::initWithIdentifier");
	self=[super initWithIdentifier:fp8];
	if(self)
	{
		[inputUpdateVelocity setBooleanValue:NO];

		[inputBounce setDoubleValue:1.0];

		[inputDrag setDoubleValue:0.0];

		[inputColor setRed:0.8 green:1.0 blue:0.8 alpha:0.5];
	}
	return self;
}


- (BOOL)setup:(QCOpenGLContext *)context
{
	[super setup:context];

//	NSLog(@"ParticleColliderPatch::setup");

	VEE_OpcodeCollision *oc=new VEE_OpcodeCollision();
	[_object setObject:oc];

	return YES;
}
- (void)cleanup:(QCOpenGLContext *)context
{
	[super cleanup:context];

//	NSLog(@"ParticleColliderPatch::cleanup");
	// _object takes care of releasing our VEE_OpcodeCollision
}


- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	[super execute:context time:time arguments:arguments];

//	NSLog(@"ParticleColliderPatch::execute");

	VEE_OpcodeCollision *oc=(VEE_OpcodeCollision *)[_object object];

	if( [inputFaces wasUpdated] )
	{
//		NSLog(@"ParticleColliderPatch::execute faces updated");
        oc->meshClear();
		if( [inputFaces structureValue] )
		{
//			NSLog(@"ParticleColliderPatch::execute faces is good %d",[[inputFaces structureValue] count]);
			int i;
			for(i=0;i< [[inputFaces structureValue] count] ;i+=9)
			{
				double x1 = [[[inputFaces structureValue] memberForKey:[NSString stringWithFormat:@"%d",i  ]] doubleValue];
				double y1 = [[[inputFaces structureValue] memberForKey:[NSString stringWithFormat:@"%d",i+1]] doubleValue];
				double z1 = [[[inputFaces structureValue] memberForKey:[NSString stringWithFormat:@"%d",i+2]] doubleValue];
				double x2 = [[[inputFaces structureValue] memberForKey:[NSString stringWithFormat:@"%d",i+3]] doubleValue];
				double y2 = [[[inputFaces structureValue] memberForKey:[NSString stringWithFormat:@"%d",i+4]] doubleValue];
				double z2 = [[[inputFaces structureValue] memberForKey:[NSString stringWithFormat:@"%d",i+5]] doubleValue];
				double x3 = [[[inputFaces structureValue] memberForKey:[NSString stringWithFormat:@"%d",i+6]] doubleValue];
				double y3 = [[[inputFaces structureValue] memberForKey:[NSString stringWithFormat:@"%d",i+7]] doubleValue];
				double z3 = [[[inputFaces structureValue] memberForKey:[NSString stringWithFormat:@"%d",i+8]] doubleValue];
				oc->meshAddTri(
								VEE_Vector3(x1,y1,z1),
								VEE_Vector3(x2,y2,z2),
								VEE_Vector3(x3,y3,z3)
							);
//				NSLog(@"ParticleColliderPatch::execute faces addTri(%f,%f,%f,%f,%f,%f,%f,%f,%f)",x1,y1,z1,x2,y2,z2,x3,y3,z3);
			}
		}
        oc->meshCommit();
	}

	if( [inputBounce wasUpdated] )
        oc->setValueFloat("bounce", [inputBounce doubleValue]);
	if( [inputDrag wasUpdated] )
        oc->setValueFloat("drag", [inputDrag doubleValue]);

	return YES;
}

@end
