#import "ParticleObjectSubstantialPatchAbstract.h"
#import "QCIndexPort.h"

@interface ParticleEmitterPatch : ParticleObjectSubstantialPatchAbstract
{
	ParticleObjectPort *inputEmittedObject;

// 'emit' is redundant with 'enabled'
//	QCBooleanPort *inputEmit;
	QCNumberPort *inputRate;
	QCIndexPort *inputMaxCount;
// it looks like 'accumulate' just builds a list of objects generated during the last 'update' event..  not useful to modulate.
//	QCBooleanPort *inputAccumulate;
	QCBooleanPort *inputInheritVelocity;
//	QCNumberPort *inputCollisionRate; // @@@ ?
//	QCNumberPort *inputCollisionNewRate; // @@@ ?


	// VEE child-operators, controlled by ParticleEmitterPatchUI
	ParticleOperatorPort **_childOperatorArray;
	int _childOperatorArrayCount;
	VEE_ValueOperator **_childOperatorArrayOld;

	VEE_Object *_emittedObject;
}

- (id)attributes;
- (id)initWithIdentifier:(id)fp8;
- (BOOL)setup:(QCOpenGLContext *)context;
- (void)cleanup:(QCOpenGLContext *)context;
- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments;

- (NSDictionary*)state;
- (BOOL)setState:(NSDictionary*)state;
- (void)addChildOperator;
- (void)removeChildOperator;
@end