#import "ParticleForceExplosionPatch.h"
#import "vee_explosion.h"

@implementation ParticleForceExplosionPatch

- (id)attributes
{
	NSMutableDictionary *at=[[super attributes] mutableCopy];
	[at setObject:@"Kineme Particle Force: Explosion" forKey:@"name"];
	return at;
}


- (id)initWithIdentifier:(id)fp8
{
//	NSLog(@"ParticleForceExplosionPatch::initWithIdentifier");
	self=[super initWithIdentifier:fp8];
	if(self)
	{
		[inputRange setDoubleValue:1.0];

		[inputMagnitude setDoubleValue:1.0];

		[inputColor setRed:0.8 green:1.0 blue:0.8 alpha:0.5];
	}
	return self;
}


- (BOOL)setup:(QCOpenGLContext *)context
{
	[super setup:context];

//	NSLog(@"ParticleForceExplosionPatch::setup");

	VEE_Explosion *e=new VEE_Explosion();
	[_object setObject:e];

	return YES;
}
- (void)cleanup:(QCOpenGLContext *)context
{
	[super cleanup:context];

//	NSLog(@"ParticleForceExplosionPatch::cleanup");
	// _object takes care of releasing our VEE_Explosion
}


- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	[super execute:context time:time arguments:arguments];

//	NSLog(@"ParticleForceExplosionPatch::execute");

	VEE_Explosion *e=(VEE_Explosion *)[_object object];

	if( [inputMagnitude wasUpdated] )
		e->setValueFloat("magnitude",[inputMagnitude doubleValue]);
	if( [inputRange wasUpdated] )
		e->setValueFloat("range",[inputRange doubleValue]);

	return YES;
}

@end
