#import "ParticleForceWindPatch.h"
#import "vee_wind.h"

@implementation ParticleForceWindPatch

- (id)attributes
{
	NSMutableDictionary *at=[[super attributes] mutableCopy];
	[at setObject:@"Kineme Particle Force: Wind" forKey:@"name"];
	return at;
}


- (id)initWithIdentifier:(id)fp8
{
//	NSLog(@"ParticleForceWindPatch::initWithIdentifier");
	self=[super initWithIdentifier:fp8];
	if(self)
	{
		[inputNx setDoubleValue:1.0];

		[inputStrength setDoubleValue:1.0];

		[inputGustStrength setDoubleValue:0.0];

		[inputGustFrequency setDoubleValue:0.5];
	}
	return self;
}


- (BOOL)setup:(QCOpenGLContext *)context
{
	[super setup:context];

//	NSLog(@"ParticleForceWindPatch::setup");

	VEE_Wind *w=new VEE_Wind();
	w->setVisible(false);
	[_object setObject:w];

	return YES;
}
- (void)cleanup:(QCOpenGLContext *)context
{
	[super cleanup:context];

//	NSLog(@"ParticleForceWindPatch::cleanup");
	// _object takes care of releasing our VEE_Vortex
}


- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	[super execute:context time:time arguments:arguments];

//	NSLog(@"ParticleForceWindPatch::execute");

	VEE_Wind *w=(VEE_Wind *)[_object object];

	{
		VEE_Vector3 l=w->getDirection();
		if( [inputNx wasUpdated] )
			l.x=[inputNx doubleValue];
		if( [inputNy wasUpdated] )
			l.y=[inputNy doubleValue];
		if( [inputNz wasUpdated] )
			l.z=[inputNz doubleValue];
		w->setDirection(l);
	}

	if( [inputStrength wasUpdated] )
		w->setValueFloat("strength",[inputStrength doubleValue]);
	if( [inputGustStrength wasUpdated] )
		w->setValueFloat("gustiness",[inputGustStrength doubleValue]);
	if( [inputGustFrequency wasUpdated] )
		w->setValueFloat("gustfreq",[inputGustFrequency doubleValue]);

	return YES;
}

@end
