#import "QCPatch.h"
#import "QCOpenGLContext.h"
#import "QCColorPort.h"

#import "ParticleLooksPort.h"
#import "vee_looks_color_table.h"

@interface ParticleLooksColorTablePatch : QCPatch
{
	ParticleLooksPort *outputLooks;


	// VEE color port array, controlled by ParticleLooksColorTablePatchUI
	QCColorPort **_colorArray;
	int _colorArrayCount;

	VEE_RgbaTable *_rgbatable;
	VEE_LooksColorTable *_looksColorTable;
	VEE_ValueLooks *_valueLooks;

	ParticleLooks *_looks;
}

+ (int)executionModeWithIdentifier:(id)fp8;
+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8;
+ (int)timeModeWithIdentifier:(id)fp8;

- (id)initWithIdentifier:(id)fp8;

- (BOOL)setup:(QCOpenGLContext *)context;
- (void)cleanup:(QCOpenGLContext *)context;

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments;

- (void)addColor;
- (void)removeColor;

- (NSDictionary*)state;
- (BOOL)setState:(NSDictionary*)state;
@end