#import "QCPatch.h"
#import "QCOpenGLContext.h"

#import "ParticleObjectPort.h"
#import "ParticleOperatorPort.h"

@interface ParticleObjectPatchAbstract : QCPatch
{
	QCBooleanPort *inputEnable; // corresponds with VEE's "done" flag
	QCNumberPort *inputAgeLimit;

	ParticleObjectPort *outputObject;
	ParticleObject *_object; // we assume that the object represented is a VEE_Particle2 or subclass, since this class implements self-operators


	// VEE self-operator port array, controlled by ParticleObjectPatchAbstractUI
	ParticleOperatorPort **_operatorArray;
	int _operatorArrayCount;
	VEE_ValueOperator **_operatorArrayOld;
}

+ (int)executionModeWithIdentifier:(id)fp8;
+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8;
+ (int)timeModeWithIdentifier:(id)fp8;

- (id)initWithIdentifier:(id)fp8;

- (BOOL)setup:(QCOpenGLContext *)context;
- (void)cleanup:(QCOpenGLContext *)context;

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments;

- (void)addOperator;
- (void)removeOperator;

- (NSDictionary*)state;
- (BOOL)setState:(NSDictionary*)state;
@end