#import "ParticleObjectSubstantialPatchAbstract.h"

#import "vee_particle2.h"

@implementation ParticleObjectSubstantialPatchAbstract

- (id)initWithIdentifier:(id)fp8
{
//	NSLog(@"ParticleObjectSubstantialPatchAbstract::initWithIdentifier");
	self=[super initWithIdentifier:fp8];
	if(self)
	{
		[inputVisible setBooleanValue:YES];

		[inputUpdateVelocity setBooleanValue:YES];

		[inputSize setDoubleValue:1.0];
		[inputSize setMinDoubleValue:0.0];

		[inputMass setDoubleValue:1.0];
//		[inputMass setMinDoubleValue:0.0];  // we don't care whether it's negative

		[inputArea setDoubleValue:1.0];
//		[inputArea setMinDoubleValue:0.0];  // we don't care whether it's negative
	}
	return self;
}

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	[super execute:context time:time arguments:arguments];

//	NSLog(@"ParticleObjectSubstantialPatchAbstract::execute");

	VEE_Particle2 *o=(VEE_Particle2 *)[_object object];

	if( [inputVisible wasUpdated] )
		o->setVisible( [inputVisible booleanValue] );

	if( [inputUpdateVelocity wasUpdated] )
		o->setVelocityUpdate( [inputUpdateVelocity booleanValue] );

	{
		VEE_Vector3 l=o->location();
		if( [inputX wasUpdated] )
			l.x=[inputX doubleValue];
		if( [inputY wasUpdated] )
			l.y=[inputY doubleValue];
		if( [inputZ wasUpdated] )
			l.z=[inputZ doubleValue];
		o->setLocation(l);
	}

	{
		VEE_Vector3 v=o->velocity();
		if( [inputVx wasUpdated] )
			v.x=[inputVx doubleValue];
		if( [inputVy wasUpdated] )
			v.y=[inputVy doubleValue];
		if( [inputVz wasUpdated] )
			v.z=[inputVz doubleValue];
		o->setVelocity(v);
	}

	if( [inputTheta wasUpdated] )
		o->setRotation( [inputTheta doubleValue] );

	if( [inputOmega wasUpdated] )
		o->setOmega( [inputOmega doubleValue] );

	if( [inputSize wasUpdated] )
		o->setSize( [inputSize doubleValue] );

	if( [inputMass wasUpdated] )
		o->setMass( [inputMass doubleValue] );

	if( [inputArea wasUpdated] )
		o->setArea( [inputArea doubleValue] );

	if( [inputColor wasUpdated] )
		o->setColor
		(
			VEE_Rgba
			(
				[inputColor redComponent],
				[inputColor greenComponent],
				[inputColor blueComponent],
				[inputColor alphaComponent]
			)
		);

	return YES;
}

@end
