#import "QCPatch.h"
#import "QCOpenGLContext.h"
#import "QCIndexPort.h"

#import "ParticleOperatorPort.h"

@interface ParticleOperatorPatchAbstract : QCPatch
{
	QCIndexPort *inputType;

	ParticleOperatorPort *outputOperator;

	ParticleOperator *_op;
}

+ (int)executionModeWithIdentifier:(id)fp8;
+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8;
+ (int)timeModeWithIdentifier:(id)fp8;

- (id)initWithIdentifier:(id)fp8;

- (BOOL)setup:(QCOpenGLContext *)context;
- (void)cleanup:(QCOpenGLContext *)context;

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments;
@end