#import "ParticleOperatorVectorPatchAbstract.h"

#import "vee_value_operator.h"


@implementation ParticleOperatorVectorPatchAbstract

- (id)attributes
{
	NSMutableDictionary *at=[[super attributes] mutableCopy];

	// @@@ or is there some way we can easily retrieve this from the 'menu' key specified in the patch's xml file?
	NSString *typeString;
	switch( [inputType indexValue] )
	{
		case 0:
			typeString=[NSString stringWithFormat:@"Add %@ Object Location",_operatorName];
			break;
		case 1:
			typeString=[NSString stringWithFormat:@"Add %@ Object Velocity",_operatorName];
			break;
		case 2:
			typeString=[NSString stringWithFormat:@"%@ Object Color",_operatorName];
			break;
		case 3:
			typeString=[NSString stringWithFormat:@"%@ Object Location",_operatorName];
			break;
		case 4:
			typeString=[NSString stringWithFormat:@"%@ Object Velocity",_operatorName];
			break;
		case 5:
			typeString=[NSString stringWithFormat:@"%@ Gravity",_operatorName];
			break;
		case 6:
			typeString=[NSString stringWithFormat:@"%@ Vortex Axis",_operatorName];
			break;
		case 7:
			typeString=[NSString stringWithFormat:@"%@ Wind Direction",_operatorName];
			break;
	}

	NSString *s=[NSString stringWithFormat:@"Kineme Particle Operator: %@",typeString];
	if( ![s isEqualToString:[at objectForKey:@"name"]] )
		[at setObject:s forKey:@"name"];

	return at;
}


- (id)initWithIdentifier:(id)fp8
{
//	NSLog(@"ParticleOperatorVectorPatchAbstract::initWithIdentifier");
	self=[super initWithIdentifier:fp8];
	if(self)
		[inputType setMaxIndexValue:7];
	return self;
}




- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	[super execute:context time:time arguments:arguments];

//	NSLog(@"ParticleOperatorVectorPatchAbstract::execute");

	VEE_ValueOperator *vop=[_op op];

	// 'wasUpdated' is not used here --- we need to always ->set() again because the _vrv is clone()d.
	switch( [inputType indexValue] )
	{
		// clone()d because the ValueOperator->set() takes ownership of the Value.
		case 0:
			vop->set("addlocation",_v->clone());
			break;
		case 1:
			vop->set("addvelocity",_v->clone());
			break;
		case 2:
			vop->set("color",_v->clone());
			break;
		case 3:
			vop->set("location",_v->clone());
			break;
		case 4:
			vop->set("velocity",_v->clone());
			break;
		case 5:
			vop->set("gravity",_v->clone());
			break;
		case 6:
			vop->set("axis",_v->clone());
			break;
		case 7:
			vop->set("direction",_v->clone());
			break;
	}

	return YES;
}

@end
