#import "ParticleOperatorVectorRandomPatch.h"

#import "vee_value_operator.h"


@implementation ParticleOperatorVectorRandomPatch

- (id)initWithIdentifier:(id)fp8
{
//	NSLog(@"ParticleOperatorVectorRandomPatch::initWithIdentifier");
	self=[super initWithIdentifier:fp8];
	if(self)
	{
		[inputMaxX setDoubleValue:1.0];
		[inputMaxY setDoubleValue:1.0];
		[inputMaxZ setDoubleValue:1.0];

		_operatorName=@"Random";
	}
	return self;
}



- (BOOL)setup:(QCOpenGLContext *)context
{
	[super setup:context];

//	NSLog(@"ParticleOperatorVectorRandomPatch::setup");

	_v=new VEE_ValueRandomVector3;

	return YES;
}
- (void)cleanup:(QCOpenGLContext *)context
{
	[super cleanup:context];

//	NSLog(@"ParticleOperatorVectorRandomPatch::cleanup");

	delete _v;
}


- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
//	NSLog(@"ParticleOperatorVectorRandomPatch::execute");

	VEE_ValueRandomVector3 *vrv=(VEE_ValueRandomVector3 *)_v;

	if(
		[inputMinX wasUpdated]
		|| [inputMinY wasUpdated]
		|| [inputMinZ wasUpdated]
		|| [inputMaxX wasUpdated]
		|| [inputMaxY wasUpdated]
		|| [inputMaxZ wasUpdated]
	)
		vrv->setRanges
		(
			VEE_Vector3
			(
				[inputMinX doubleValue],
				[inputMinY doubleValue],
				[inputMinZ doubleValue]
			),
			VEE_Vector3
			(
				[inputMaxX doubleValue],
				[inputMaxY doubleValue],
				[inputMaxZ doubleValue]
			)
		);

	[super execute:context time:time arguments:arguments];

	return YES;
}

@end
