#import "QCPatch.h"
#import "QCIndexPort.h"
#import "QCOpenGLContext.h"

#import "ParticleRenderClassPort.h"
#import "vee_render_class.h"

@interface ParticleRenderClassPatch : QCPatch
{
	QCIndexPort *inputAlignment;
	QCNumberPort *inputLengthScale;
	QCNumberPort *inputMaxLengthScale;
// @@@ Shader

	ParticleRenderClassPort *outputRenderClass;

	ParticleRenderClass *_renderClass;
}

+ (int)executionModeWithIdentifier:(id)fp8;
+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8;
+ (int)timeModeWithIdentifier:(id)fp8;

- (id)initWithIdentifier:(id)fp8;

- (BOOL)setup:(QCOpenGLContext *)context;
- (void)cleanup:(QCOpenGLContext *)context;

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments;
@end