#import "QCPatch.h"
#import "QCOpenGLContext.h"

#import "QCIndexPort.h"
#import "ParticleScenePort.h"

#import "vee_gl_renderer.h"
#import "gee_gl_material.h"
#import "gee_gl_renderer.h"
#import "gee_display_lists.h"

#import "QCOpenGLPort_ZBuffer.h"
#import "QCOpenGLPort_Culling.h"
#import "QCOpenGLPort_Blending.h"

@interface ParticleRendererPatch : QCPatch
{
	ParticleScenePort *inputScene;
	QCBooleanPort *inputShowBoxes;
	QCNumberPort *inputSize;
//	QCNumberPort *inputLengthScale; // @@@ i can't figure out what this does.
	QCNumberPort *inputAlpha;
//	QCNumberPort *inputFOV; // incompatible with QC's rendering model
//	QCNumberPort *inputFade; // @@@ i can't figure out what this does.
//	QCNumberPort *inputFixedFade; // @@@ i can't figure out what this does.
//	QCNumberPort *inputTailDispersion; // @@@ i can't figure out what this does.
//	QCBooleanPort *inputContinuousTails; // @@@ i can't figure out what this does.
	QCIndexPort *inputRenderOrder;
	//QCIndexPort *inputBlending;
	QCOpenGLPort_ZBuffer	*inputZBuffer;
	QCOpenGLPort_Culling	*inputCulling;
	QCOpenGLPort_Blending	*inputBlend;	


	VEE_GlRenderer *veeGl;
//	GEE_GlRenderer *geeGl;
	double _lastFrameTime;
	
	VEE_SceneBox *_scenebox;
}

+ (int)executionModeWithIdentifier:(id)fp8;
+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8;
+ (int)timeModeWithIdentifier:(id)fp8;

- (id)attributes;

- (id)initWithIdentifier:(id)fp8;

- (BOOL)setup:(QCOpenGLContext *)context;
- (void)cleanup:(QCOpenGLContext *)context;

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments;
@end