#import "QCPatch.h"
#import "QCOpenGLContext.h"

#import "QCIndexPort.h"

#import "ParticleObjectPort.h"
#import "ParticleScenePort.h"

#import "vee_scene.h"
//#import "gee_engine.h"


@interface ParticleScenePatch : QCPatch
{
	QCIndexPort *inputSplitThreshold;
	QCIndexPort *inputCollapseThreshold;
	QCIndexPort *inputAllowRecursionLevels;
	
	QCNumberPort *inputBoundLowerX;
	QCNumberPort *inputBoundLowerY;
	QCNumberPort *inputBoundLowerZ;
	QCNumberPort *inputBoundUpperX;
	QCNumberPort *inputBoundUpperY;
	QCNumberPort *inputBoundUpperZ;

	ParticleScenePort *outputScene;
	QCIndexPort *outputObjectCount;
	QCIndexPort *outputForceCount;


//	GEE_Engine *geeEngine;

	VEE_SceneBox *_scenebox;
	ParticleScene *_scene; // wrapper for _scenebox

	double _lastFrameTime;
	




	ParticleObjectPort **_objectArray;
	int _objectArrayCount;
	VEE_Object **_objectArrayOld;
}

+ (int)executionModeWithIdentifier:(id)fp8;
+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8;
+ (int)timeModeWithIdentifier:(id)fp8;

- (id)attributes;

- (id)initWithIdentifier:(id)fp8;

- (BOOL)setup:(QCOpenGLContext *)context;
- (void)cleanup:(QCOpenGLContext *)context;

- (void)addObject;
- (void)removeObject;

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments;
@end