#import "ParticleOperatorPort.h"

@implementation ParticleOperatorPort : QCObjectPort
+ (Class)baseClass
{
	return [ParticleOperatorPort class];
}
- (Class)valueClass
{
	return [ParticleOperator class];
}
- (Class)objectClass
{
	return [ParticleOperator class];
}

- (BOOL)acceptValuesOfClass:(Class)c
{
	return [c isSubclassOfClass:[ParticleOperator class]];
}
- (NSString *)tooltipString
{
	return [[self object] description];
}


- (ParticleOperator *)operatorValue
{
	return [self object];
}
- (id)value
{
	return [self object];
}

- (void)setOperatorValue:(ParticleOperator *)op
{
	[self setObject:op];

}
- (BOOL)setValue:(id)v
{
	[self setObject:v];
	return YES;
}

- (id)initWithNode:(QCPatch *)node arguments:(NSDictionary *)arguments;
{
	self=[super initWithNode:node arguments:arguments];
	return self;
}
@end
