#import "ParticleScenePort.h"

@implementation ParticleScenePort : QCObjectPort
+ (Class)baseClass
{
	return [ParticleScenePort class];
}
- (Class)valueClass
{
	return [ParticleScene class];
}
- (Class)objectClass
{
	return [ParticleScene class];
}

- (BOOL)acceptValuesOfClass:(Class)c
{
	return [c isSubclassOfClass:[ParticleScene class]];
}
- (NSString *)tooltipString
{
	return [[self object] description];
}


- (ParticleScene *)sceneValue
{
	return [self object];
}
- (id)value
{
	return [self object];
}

- (void)setSceneValue:(ParticleScene *)scene
{
	[self setObject:scene];

}
- (BOOL)setValue:(id)v
{
	[self setObject:v];
	return YES;
}

- (id)initWithNode:(QCPatch *)node arguments:(NSDictionary *)arguments;
{
	self=[super initWithNode:node arguments:arguments];
	return self;
}
@end
