/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_CURVE_PARTICLE_H
#define VEE_CURVE_PARTICLE_H

#include <vee_particle.h>
#include <vee_math.h>

#include <vector>

class VEE_CurveParticle : public VEE_Particle
{
public:
  /* class Point 
  {
  public:
    VEE_Vector3 m_location;
    VEE_Vector3 m_location;
    
    };*/
  

  VEE_CurveParticle();
  virtual ~VEE_CurveParticle();

  virtual bool setValue(const char *, VEE_Value *);
  virtual VEE_Variable getVariable(const char *) const;

  virtual void updateVelocity(float);
  virtual void update(float);
  
  virtual VEE_Object *clone() const;
  static VEE_Object * factory();

  void resizeCurve(uint);

  uint pointsToRender() const { return m_activeKnots; }

  const VEE_Vector3 & location(uint i) { return m_locations[i]; }

protected:
  std::vector<VEE_Vector3> m_locations;
  std::vector<VEE_Vector3> m_velocities;
  std::vector<VEE_Vector3> m_forces;

  float m_knotInerval;
  uint  m_activeKnots;
};

#endif
