/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_EXPLOSION_H
#define VEE_EXPLOSION_H

#include <vee_force_object.h>

class VEE_Explosion : public VEE_ForceObject
{
public:
  VEE_Explosion();
  VEE_Explosion(const VEE_Vector3 & location, 
		float range,
		float magnitude, 
		float ageLimit);

  virtual ~VEE_Explosion();

  virtual bool setValue(const char *, VEE_Value *);
  virtual VEE_Variable getVariable(const char *) const;
  virtual VEE_Object * clone() const;

  virtual void update(float dt);

  virtual void getForce(VEE_Vector3 *force,
			const VEE_Vector3 &velocity,
			const VEE_Vector3 &location);
  
  virtual void boundingBoxOfForce(VEE_BoundingBox *box);
  
  static VEE_Object * factory();

  float currentShockRange() { return m_currentShockRange; }
  void setCurrentShockRange(float r) { m_currentShockRange = r; }

protected:

  float m_range;
  float m_magnitude;

  float m_currentShockRange;
};

#endif
