/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_GARBAGE_HPP
#define VEE_GARBAGE_HPP

#include <set>

class VEE_GarbageBin
{
public:
  VEE_GarbageBin() {}
  
  void add(void *item) { m_items.insert(item); }
  void clear() { m_items.clear(); }
  
  typedef std::set<void *>::iterator iterator;

  iterator begin() { return m_items.begin(); }
  iterator end()   { return m_items.end(); }
  
  std::set<void *> m_items;
  
};

class VEE_Garbage
{
public:
  VEE_Garbage(VEE_GarbageBin *bin = 0) : m_bin(bin) {}
  virtual ~VEE_Garbage();
  
  virtual void setGarbageBin(VEE_GarbageBin *bin);
  
private:
  VEE_GarbageBin * m_bin;
};

#endif
