/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <vee_has_values.h>

#include <vee_error.h>
#include <vee_values.h>


bool VEE_HasValues::setValue(const char *, VEE_Value *)
{
  return false;
}

bool VEE_HasValues::setValueInt(const char *id, int v)
{
  // VEE_trace("VEE_HasValues::setValueFloat # %f", v);
  VEE_ValueInt tmp(v);
  return setValue(id, &tmp);
}

bool VEE_HasValues::setValueFloat(const char *id, float v)
{
  // VEE_trace("VEE_HasValues::setValueFloat # \"%s\" %f", id, v);
  VEE_ValueFloat tmp(v);
  return setValue(id, &tmp);
}

bool VEE_HasValues::setValueVector3(const char *id, const VEE_Vector3 &v)
{
  VEE_ValueVector3 tmp(v);
  return setValue(id, &tmp);
}

bool VEE_HasValues::setValueVector3f(const char *id, float x, float y, float z)
{
  return setValueVector3(id, VEE_Vector3(x, y, z));
}

bool VEE_HasValues::setValueMatrix3(const char *id, const VEE_Matrix3 &v)
{
  VEE_ValueMatrix3 tmp(v);
  return setValue(id, &tmp);
}


bool VEE_HasValues::setValueRgba(const char *id, const VEE_Rgba &rgba)
{
  VEE_ValueRgba tmp(rgba);
  return setValue(id, &tmp);
}
