/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <vee_looks_color_table.h>

#include <vee_particle.h>

VEE_LooksColorTable::~VEE_LooksColorTable()
{}

VEE_Rgba VEE_LooksColorTable::color()
{
  float relative = m_host->age() / m_host->ageLimit();
  
  return (*m_colorTable).getScaled(relative);
}

VEE_Looks *VEE_LooksColorTable::clone() const
{
  return new VEE_LooksColorTable(*this);
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

VEE_LooksColorTable2::~VEE_LooksColorTable2()
{}

VEE_Rgba VEE_LooksColorTable2::color()
{
  float relative = m_host->age() / m_maxAge;
  
  return (*m_colorTable).getScaled(relative);
}

VEE_Looks *VEE_LooksColorTable2::clone() const
{
  return new VEE_LooksColorTable2(*this);
}
