/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <vee_misc.h>

/** Test if given point is inside a bounding box. 

    @arg location Location of the point
    
    @arg low This vector is the corner of the box with smallest x, y
    and z.

    @arg high This vector is the corner of the box with greatest x, y
    and z.

    @return This method return true if the point is within the box and
    false otherwise.
*/

bool VEE_within(const VEE_Vector3 &location,
		const VEE_Vector3 &low,
		const VEE_Vector3 &high)
{
  return ((location[0] >= low[0]) && (location[0] <= high[0]) &&
	  (location[1] >= low[1]) && (location[1] <= high[1]) && 
	  (location[2] >= low[2]) && (location[2] <= high[2]));
}
