/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <vee_operator.h>

#include <vee_error.h>

#include <typeinfo>


/** Operates on an object - MUST BE OVERRIDDEN. */

void VEE_Operator::operate(VEE_Object *, float)
{
  VEE_fatal
    ("VEE_Operator::operate # This method MUST be overridden (class %s)",
     typeid(*this).name());
}

/** Clones this object - MUST BE OVERRIDDEN. */

VEE_Operator * VEE_Operator::clone() const
{
  VEE_fatal
    ("VEE_Operator::clone # This method MUST be overridden (class %s)",
     typeid(*this).name());

  return 0;
}
