/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_OPERATOR_CALLBACK_H
#define VEE_OPERATOR_CALLBACK_H

#include <vee_operator.h>

typedef void (*VEE_OPERATOR_FUNC)(VEE_Object *, float, void *);

class VEE_OperatorCallback : public VEE_Operator
{
public:
  VEE_OperatorCallback() : m_func(0), m_clienData(0) {}
  virtual ~VEE_OperatorCallback();
  
  virtual void operate(VEE_Object *, float);
  virtual VEE_Operator * clone() const;

  void setCallback(VEE_OPERATOR_FUNC func, void * clientData)
    { m_func = func; m_clienData = clientData; }

 protected:
  
  VEE_OPERATOR_FUNC m_func;
  void *            m_clienData;
};

#endif
