/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_OPERATOR_MATH_H
#define VEE_OPERATOR_MATH_H

#include <vee_object.h>
#include <vee_operator_random.h>

template <class T>
class VEE_OperatorMath : public VEE_Operator
{
public:
  VEE_OperatorMath();
  virtual ~VEE_OperatorMath();

  virtual void operate(VEE_Object *, float);
  virtual VEE_Operator * clone() const;

  
  void setId(const std::string &id) { m_id = id; }
  void setOperation(VEE_MathOperation op) { m_operation = op; }

  void set(const T &v) { m_value = v; }
  
  static inline T defaultValue();

protected:

  VEE_MathOperation m_operation;
  std::string       m_id;
  T                 m_value;

};

// template <float>
template<>
inline float VEE_OperatorMath<float>::defaultValue()
{
  return 0.0;
}

typedef VEE_OperatorMath<float> VEE_OperatorMathFloat;

#endif
