/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_OPERATOR_OBJECT_H
#define VEE_OPERATOR_OBJECT_H

#include <vee_particle.h>

#include <vee_operator_list.h> 

class VEE_OperatorObject : public VEE_Particle
{
public:
  VEE_OperatorObject() {}
  virtual ~VEE_OperatorObject();
  
  virtual VEE_Object * clone() const;  
  virtual void update(float);

  void appendOperator(VEE_Object *target, VEE_Operator *o)
  { m_operators.appendOperator2(target, o); }

  void appendOperator2(VEE_Object *target, VEE_Operator *o, const char * name)
  { m_operators.appendOperator2(target, o, name); }

protected:
  VEE_OperatorList m_operators;
};

#endif

