/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_OPERATOR_VOLUME_H
#define VEE_OPERATOR_VOLUME_H

#include <vee_clonable_pointer.h>
#include <vee_operator.h>
#include <vee_volume.h>

class VEE_OperatorVolume : public VEE_Operator
{
public:
  VEE_OperatorVolume();
  ~VEE_OperatorVolume();
  
  virtual bool setValue(const char *, VEE_Value *);
  virtual void operate (VEE_Object *, float);
  virtual VEE_Operator * clone () const;

  void setVolume(VEE_Volume * vol);
  void setId(const std::string & id) { m_id = id; }

protected:
  VEE_ClonablePointer<VEE_Volume> m_volume;

  std::string m_id;
};

#endif
