/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_PARAMETER_H
#define VEE_PARAMETER_H

#include <string>

class VEE_HasValues;

/** Descriction of a parameter. */
class VEE_Parameter
{
public:
  VEE_Parameter() {}
  virtual ~VEE_Parameter() {}

  virtual VEE_Parameter * clone() const;
  virtual bool setValue(VEE_HasValues *);

  const std::string & name() const 
  { return m_name.size() ? m_name : m_id; }
  void setName(const std::string &name) { m_name = name; }

  const std::string & id() const { return m_id; }
  void setId(const std::string &id) { m_id = id; }

protected:
  std::string m_id;
  std::string m_name;
};

#endif
