/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <vee_particle2.h>

#include <vee_error.h>
#include <vee_math.h>

VEE_Particle2::VEE_Particle2()
{}

VEE_Particle2::~VEE_Particle2()
{}

bool VEE_Particle2::setValue(const char *id, VEE_Value *msg)
{
  if(strncmp(id, "selfops/", 8) == 0) {
    return m_slist.setValue(id + 8, msg);
  }
  return VEE_Particle::setValue(id, msg);
}

VEE_Object *VEE_Particle2::clone() const
{
  return new VEE_Particle2(*this);
}

void VEE_Particle2::update(float dt)
{
  m_location += m_velocity * dt;
  m_age += dt;
  m_rotationRadians = VEE_checkRadianRange(m_rotationRadians + m_omega * dt);

  if(m_age > m_ageLimit)
    m_done = true;

  if(m_looks) 
    m_color = m_looks->color();
  
  // VEE_trace("VEE_Particle2::update # %p looks = %p", this, m_looks);
  
  m_slist.operate(this, dt);
}
