/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_PTR_H
#define VEE_PTR_H

class VEE_Ptr
{
public:

  static inline int distance(const void *p1, const void *p2)
  { 
    const char * c1 = (const char *) p1;
    const char * c2 = (const char *) p2;
    
    return c1 - c2;
  }

  template <class T>
  static inline T * offset(T *p, int offsetBytes)
  { return (T *) (((char *) p) + offsetBytes); }

  template <class T>
  static inline const T * offset(const T *p, int offsetBytes)
  { return (T *) (((char *) p) + offsetBytes); }

  // static inline const void * offset(const void *p, int offsetBytes)
  // { return ((char *) p) + offsetBytes; }

  /// Returns a random number between zero and one.
  static inline float ptrToRandom(void * ptr)
  {
    unsigned seed = (int) ptr;
    seed = seed * 134695621 + 1;
    seed = seed * 134695621 + 1;
    seed = seed * 134695621 + 1;

    return seed * (1.0 / (float) ((unsigned) 0xffffffff));
  }

};

#endif
