/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_RANDOM_FORCE_H
#define VEE_RANDOM_FORCE_H

#include <vee_clonable_pointer.h>
#include <vee_scene.h>
#include <vee_object.h>
#include <vee_volume.h>

class VEE_RandomForce : public VEE_ForceObject
{
public:
  VEE_RandomForce();
  virtual ~VEE_RandomForce();

  virtual bool setValue(const char *, VEE_Value *);
  virtual VEE_Variable getVariable(const char *) const;
  virtual VEE_Object * clone() const;

  void getForce(VEE_Vector3 *force,
		const VEE_Vector3 &,
                const VEE_Vector3 &);
  void boundingBoxOfForce(VEE_BoundingBox *box);


  void setScale(const VEE_Vector3 & s) { m_locScale = s; }

  static VEE_Object * factory();

protected:

  VEE_Vector3       m_magnitude;
  float             m_octaveAttenuation;
  int               m_octaves;
  VEE_Vector3       m_locScale;

  VEE_ClonablePointer<VEE_Volume> m_volume;
};



#endif
