/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_TIME_H
#define VEE_TIME_H

#include <sys/time.h>

class VEE_Time
{
public:
  VEE_Time() {}
  ~VEE_Time() {}

  void getTimeOfDay() { gettimeofday(&m_tv, 0); }
  
  double secsTo(const VEE_Time &t) const
  {
    return t.m_tv.tv_sec - m_tv.tv_sec + 
      (t.m_tv.tv_usec - m_tv.tv_usec) / 1000000.0;
  }

  uint usecsTo(const VEE_Time &t) const
  {
    return (t.m_tv.tv_sec - m_tv.tv_sec) * 1000000 + 
      t.m_tv.tv_usec - m_tv.tv_usec;
  }

  double secsSince() const
  { VEE_Time tmp; tmp.getTimeOfDay(); return secsTo(tmp); }
  
  long usecs() const { return  m_tv.tv_sec * 1000000 + m_tv.tv_usec; }

protected:
  struct timeval m_tv;
};

#endif
