/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_VALUES_PTR_H
#define VEE_VALUES_PTR_H

#include <vee_clonable_pointer.h>
#include <vee_value.h>

template <typename T>
class VEE_ValuePtr : public VEE_Value
{
public:
  VEE_ValuePtr() {}
  VEE_ValuePtr(T * ptr) : m_ptr(ptr) {}
  
  virtual VEE_Value * clone() const { return new VEE_ValuePtr(*this); }

  T * object() { return m_ptr.ptr(); }
  void setObject(T * ptr) { m_ptr = ptr; }

  T * fabricate() { return m_ptr.ptr() ? m_ptr.ptr()->clone() : 0; }

protected:
  VEE_ClonablePointer<T> m_ptr;

};

#endif
