/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_VOLUME_H
#define VEE_VOLUME_H

#include <vee_has_values.h>

class VEE_BoundingBox;

/** Volume in space. Volumes are implicitly expected to be centered in
    the origin. */

class VEE_Volume : public VEE_HasValues
{
public:
  VEE_Volume() {}
  virtual ~VEE_Volume() {}
  
  virtual float inside(const VEE_Vector3 &);
  virtual void getBoundingBox(VEE_BoundingBox *);
  virtual VEE_Vector3 newRandomPoint();

  virtual VEE_Volume * clone() const;
};

#endif
