/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <vee_rigid_particle.h>

#include <vee_error.h>
#include <vee_math.h>
#include <vee_value.h>

VEE_RigidParticle::VEE_RigidParticle()
  : m_mesh(0)
{
  m_rotationAxis.make(1.0, 0.0, 0.0);
  m_objectType = VEE_OBJECT_RIGID_PARTICLE;
}

VEE_RigidParticle::~VEE_RigidParticle()
{
  /* VEE_trace("VEE_RigidParticle::~VEE_RigidParticle # %p %f %f %f",
     this, m_location.x, m_location.y, m_location.z); */
}
  
bool VEE_RigidParticle::setValue(const char *id, VEE_Value *v)
{
  bool ok = VEE_Particle2::setValue(id, v);

  if(ok) return true;

  if(strcmp(id, "axis") == 0) {
    VEE_Vector3 tmp;
    ok = v->getVector3(&tmp);
    if(ok)
      m_rotationAxis = tmp;
  }

  return ok;
}

VEE_Object *VEE_RigidParticle::clone() const
{
  return new VEE_RigidParticle(*this);
}

