/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef GEE_CAMERA_PARAMETERS_H
#define GEE_CAMERA_PARAMETERS_H

#include <vee_vector3.h>

/** Parameters of a camera that is looking at the world. */

class GEE_CameraParameters
{
public:
  GEE_CameraParameters() 
  { 
    m_location.clear(); 
    m_direction.make(1, 0, 0); 
    m_up.make(0, 1, 0); 
    m_fov  = 70;
  }

  VEE_Vector3 m_location;
  VEE_Vector3 m_direction;
  VEE_Vector3 m_up;
  float       m_fov;
};


#endif

