/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <gee_debug.h>

#include <vee_error.h>

#include <map>
#include <string>

using namespace std;

static map<string, int> params;
static int debgAll = 0;

int GEE_Debug::debug(const char * target)
{
  map<string, int>::iterator it = params.find(target);
  if(it == params.end())
    return debgAll;

  return (*it).second;
}

int GEE_Debug::debugAll()
{
  return debgAll;
}

void GEE_Debug::setDebug(const char * target, int level)
{
  VEE_trace("Debugging %s for \"%s\"", level ? "enabled" : "disabled", target);
  params[target] = level;
}

void GEE_Debug::setDebugAll(int level)
{
  VEE_trace("Debugging everything at level %d", level);
  debgAll = level;
}
