/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <gee_edit_set.h>

#include <gee_geometry.h>
#include <gee_world.h>


GEE_EditSet::GEE_EditSet()
{}

GEE_EditSet::~GEE_EditSet()
{}

void GEE_EditSet::addGeo(GEE_Geometry *g)
{
  GEE_id_t id = g->id();

  if(m_geos.find(id) != m_geos.end())
    return;
  
  g->attachEditor();
  m_geos.insert(g->id());
}

void GEE_EditSet::detach(GEE_World *w)
{
  for(iterator it = m_geos.begin(); it != m_geos.end(); it++) {
    GEE_Geometry * g = w->geometry((*it));
    if(g)
      g->detachEditor();
  }
  clear();
}

void GEE_EditSet::clear()
{
  m_geos.clear();
}
