/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef GEE_EDIT_SET_H
#define GEE_EDIT_SET_H

#include <gee_config.h>

#include <set>

class GEE_Geometry;
class GEE_World;

class GEE_EditSet
{
public:

  typedef std::set<GEE_id_t> container;
  typedef container::iterator iterator;

  GEE_EditSet();
  ~GEE_EditSet();
  
  void addGeo(GEE_Geometry *);
  void detach(GEE_World *);
  void clear();

protected:
  container m_geos;

};

#endif
