/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef GEE_ERASE_AROUND_PATH_H
#define GEE_ERASE_AROUND_PATH_H

#include <gee_path_to_x.h>
#include <gee_sphere_group.h>


class GEE_EraseAroundPath : public GEE_PathToX, public GEE_SphereGroup
{
public:
  GEE_EraseAroundPath(GEE_id_t pathId = -1, 
		      bool deleteParts = true,
		      float radiusNorm = 1.0f,
		      float exaggerateRadius = 0.0f,
		      bool useNapra = false);
  virtual ~GEE_EraseAroundPath();
  
  virtual void contained(GEE_Geometry *);

  virtual bool act(GEE_World *, const GEE_TimeStamp &);

  virtual bool read(GEE_Io *);
  virtual bool write(GEE_Io *);
  virtual const char * type();
  static GEE_Operator * create();

protected:
  virtual bool handleNewVertex(GEE_Path3D::iterator &);

  virtual void doWork(GEE_World *);

  GEE_id_t m_pathId;

  bool     m_firstUsed;
  /// If true, delete parts, else delete complete objects
  bool     m_deleteParts;

  float    m_exaggerateRadius;
  float    m_radiusNorm;

  bool     m_useNapra;
};


#endif
