/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef GEE_GROUP_AROUND_PATH_H
#define GEE_GROUP_AROUND_PATH_H

#include <gee_erase_around_path.h>

class GEE_Group;

class GEE_GroupAroundPath : public GEE_EraseAroundPath
{
public:
  GEE_GroupAroundPath(GEE_id_t pathId = -1);
  virtual ~GEE_GroupAroundPath();

  virtual bool stop(GEE_World *, const GEE_TimeStamp &);

  virtual bool read(GEE_Io *);
  virtual bool write(GEE_Io *);

  virtual const char * type();
  static GEE_Operator * create();

protected:
  virtual void doWork(GEE_World *);
  VEE_RefPtr<GEE_Geometry> m_group;
  GEE_Group               *m_groupPtr;
  GEE_id_t                 m_groupId;
};

#endif
