/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef GEE_GROUP_GEOS_H
#define GEE_GROUP_GEOS_H

#include <gee_operator.h>

class GEE_Group;

/** This class groups a series of geometries into a group. 

@author Tommi Ilmonen
*/

class GEE_GroupGeos : public GEE_Operator
{
public:
  GEE_GroupGeos(GEE_id_t groupId = -1);
  virtual ~GEE_GroupGeos();

  virtual id_container * getExtraIds();

  virtual bool act(GEE_World *, const GEE_TimeStamp &);

  virtual bool read(GEE_Io *);
  virtual bool write(GEE_Io *);
  
  virtual const char * type();
  static GEE_Operator * create();

  void addId(GEE_id_t id) { if(id != m_groupId) m_ids.insert(id); }

protected:

  GEE_id_t     m_groupId;

  id_container m_ids;  
};

#endif
