/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef GEE_INTERVAL_H
#define GEE_INTERVAL_H

#include <gee_config.h>
#include <gee_time_stamp.h>

class GEE_Io;

class GEE_Interval
{
public:
  GEE_Interval() {}
  ~GEE_Interval() {}

  const GEE_TimeStamp & begin() const { return m_begin; }
  const GEE_TimeStamp & end()   const { return m_end; }

  void setBegin(const GEE_TimeStamp & ts) { m_begin = ts; }
  void setEnd(const GEE_TimeStamp & ts)   { m_end = ts; }

  void set(const GEE_TimeStamp & ts) { m_begin = m_end = ts; }

  bool read(GEE_Io *);
  bool write(GEE_Io *);

protected:
  GEE_TimeStamp m_begin, m_end;
};


#endif
