/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef GEE_MOVER_H
#define GEE_MOVER_H

#include <gee_bounded.h>

#include <vee_vector3.h>

class GEE_Geometry;

class GEE_Mover : public GEE_Bounded
{
public:
  GEE_Mover() {}
  virtual ~GEE_Mover() {}

  /** Modifies a vertex in some way. The return value is true if the
      vertex was modified. If the vertex remains unmodified, then
      false is returned. */

  virtual bool move(VEE_Vector3 *) = 0;
  virtual void moved(GEE_Geometry *) = 0;
};

#endif
