/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef GEE_PATH_TO_CAMERA_H
#define GEE_PATH_TO_CAMERA_H

#include <gee_param_writer.h>
#include <gee_path_to_x.h>

class GEE_PathToCamera : public GEE_PathToX
{
public:
  GEE_PathToCamera(GEE_id_t pathId = -1, 
		   GEE_id_t cameraId = -1);
  virtual ~GEE_PathToCamera();

  virtual bool start(GEE_World *, const GEE_TimeStamp &);

  virtual bool read(GEE_Io *);
  virtual bool write(GEE_Io *);
  virtual const char * type();
  static GEE_Operator * create();
  
  void setFov(float fov) { m_fov = fov; }

protected:

  virtual bool handleNewVertex(GEE_Path3D::iterator &);

  GEE_ParamWriter m_writer;

  GEE_id_t        m_cameraId;
  VEE_Matrix3     m_cameraRot;
  VEE_Matrix3     m_foo;

  /// Field of view
  float           m_fov;

  GEE_World      *m_world;
};

#endif
