/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef GEE_RECOLOR_H
#define GEE_RECOLOR_H

#include <gee_bounded.h>

#include <vee_color.h>
#include <vee_vector4.h>

class GEE_Geometry;

class GEE_ReColor : public GEE_Bounded
{
public:
  GEE_ReColor() {}
  virtual ~GEE_ReColor() {}

  virtual bool recolor(const VEE_Vector3 &location,
		       VEE_Vector4 * color) = 0;
  virtual bool recolor(const VEE_Vector3 &location,
		       VEE_Rgba * color) = 0;

  virtual void recolored(GEE_Geometry *) = 0;

  virtual VEE_Rgba basicColor() = 0;
};

#endif
