/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef GEE_TEXTURE_AROUND_PATH_H
#define GEE_TEXTURE_AROUND_PATH_H

#include <gee_erase_around_path.h>

class GEE_TextureAroundPath : public GEE_EraseAroundPath
{
public:
  GEE_TextureAroundPath(GEE_id_t pathId = -1,
			float radiusNorm = 1.0f,
			float exaggerateRadius = 0.0f,
			bool useNapra = false);
  virtual ~GEE_TextureAroundPath();

  virtual bool read(GEE_Io *);
  virtual bool write(GEE_Io *);

  virtual const char * type();
  static GEE_Operator * create();

  void setTextureName(const std::string name) 
  { m_texName = name; m_texId = -1; }

protected:
  virtual void doWork(GEE_World *);
  std::string m_texName;
  int         m_texId;
};

#endif
