/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef GEE_TURN_AROUND_PATH_H
#define GEE_TURN_AROUND_PATH_H

#include <gee_path_to_x.h>

#include <vector>


class GEE_TurnAroundPath : public GEE_PathToX
{
public:
  GEE_TurnAroundPath(GEE_id_t pathId = -1, 
		     GEE_id_t geoId = -1,
		     float speed = 0.01);
  virtual ~GEE_TurnAroundPath();
  
  virtual bool start(GEE_World *, const GEE_TimeStamp &);
  virtual bool act(GEE_World *, const GEE_TimeStamp &);

  virtual bool read(GEE_Io *);
  virtual bool write(GEE_Io *);
  virtual const char * type();
  static GEE_Operator * create();

protected:

  virtual bool handleNewVertex(GEE_Path3D::iterator &);

  virtual void doTurn(GEE_World *);

  GEE_id_t m_geoId;

  uint  m_steps;
  float m_speed;
};

#endif
