/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef GEE_UNGROUP_GEOS_H
#define GEE_UNGROUP_GEOS_H

#include <gee_operator.h>
#include <gee_param_writer.h>

/** This class groups a series of geometries into a group. 

@author Tommi Ilmonen
*/

class GEE_UnGroupGeos : public GEE_Operator
{
public:
  GEE_UnGroupGeos(GEE_id_t groupId = -1);
  virtual ~GEE_UnGroupGeos();

  virtual bool act(GEE_World *, const GEE_TimeStamp &);

  virtual bool read(GEE_Io *);
  virtual bool write(GEE_Io *);
  
  virtual const char * type();
  static GEE_Operator * create();

protected:

  GEE_id_t     m_groupId;

  GEE_ParamWriter m_writer;

  id_container m_ids;  
};

#endif
