/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <gee_display_lists.h>

#include <vee_garbage.h>

 
GEE_GlDisplayLists::GEE_GlDisplayLists()
{}

GEE_GlDisplayLists::~GEE_GlDisplayLists()
{}

void GEE_GlDisplayLists::freeLists(VEE_GarbageBin *items)
{
  for(VEE_GarbageBin::iterator it = items->begin();
      it != items->end(); it++) {

    iterator myIt = m_storage.find(*it);

    if(myIt != m_storage.end()) {
      (*myIt).second.ref().freeList();
      m_storage.erase(myIt);
    }
  }
}

/** Returns a list object related to the id. If corresponding list is
    not found, then it is generated. */

GEE_GlDisplayList & GEE_GlDisplayLists::getList(void *id)
{
  return m_storage[id].ref();
}

/** Gets a pointer to a list related to the id. If corresponding list
    is not found, then NULL is returned. */

GEE_GlDisplayList * GEE_GlDisplayLists::getListPtr(void *id)
{
  iterator it = m_storage.find(id);
  return (it == m_storage.end()) ? 0 : & (*it).second.ref();
}
