/* Test what are the units of the fragment coordinates

   Author: Tommi Ilmonen
*/

uniform vec3 windowscale;

uniform sampler2D tex;
uniform sampler2D depth_map;

// uniform float particle_size;

void main (void)
{
  vec4 texcolor = texture2D(tex, gl_TexCoord[0].st);

  float fbdepth = texture2D(depth_map,
			    gl_FragCoord.xy * windowscale.xy).x;
  
  fbdepth = fbdepth / gl_FragCoord.w;
  float drawdepth = gl_FragCoord.z / gl_FragCoord.w;

  float diff = fbdepth - drawdepth;
  
  float fade = clamp(diff * gl_TexCoord[1].s, 0.0, 1.0);
  
  vec4 color = gl_Color * texcolor * fade;

  gl_FragColor = color;
}
