# Simple clouds

# Usual initializations:
from vee_init import *
from vee import *

qa = QApplication_newApp()
scene = VEE_SceneBox()
VEE_ObjectFactory_init()

height = 3.0;

v1 = VEE_Vector3()
v2 = VEE_Vector3()

# SPEEDS:
#
# HR 7.1: 140-166
#

#############################################################################


p = VEE_Particle()
p.setAgeLimit(150)

rgbatable = VEE_RgbaTable()
color = VEE_Rgba()

color.set(1.0, 1.0, 1.0, 0.0)
rgbatable.appendColor(color)
color.set(1.0, 1.0, 1.0, 1.0)
rgbatable.appendColor(color)
color.set(1.0, 1.0, 1.0, 1.0)
rgbatable.appendColor(color)
color.set(1.0, 1.0, 1.0, 1.0)
rgbatable.appendColor(color)
color.set(1.0, 1.0, 1.0, 1.0)
rgbatable.appendColor(color)
color.set(1.0, 1.0, 1.0, 0.0)
rgbatable.appendColor(color)

looks = VEE_LooksColorTable(rgbatable)
looks.thisown = 0

valueLooks = VEE_ValueLooks()
valueLooks.setLooks(looks)

p.setValue("looks", valueLooks)

#############################################################################

# Number of cloud sources
nx = 6;
# nz = 100;

location = VEE_Vector3()

ranged = 0.3

v1.make(-ranged, -ranged, -ranged)
v2.make( ranged,  ranged,  ranged)

rv = VEE_ValueRandomVector3()
rv.setRanges(v1, v2)

vo = VEE_ValueOperator()
vo.set("addlocation", rv.clone())

distance = 25.0 / nx
# distance = 1.0
# nx=6;

for i in range(0,nx):
    location.make(i * distance - 2, height, 0.0);
    cloudCreator = VEE_Emitter(p.clone())
    cloudCreator.setRate(1)
    cloudCreator.setLocation(location)
    cloudCreator.setVisible(0)
    cloudCreator.appendOperator(vo.clone())
    cloudCreator.appendOperator(vo.clone())
    cloudCreator.appendOperator(vo.clone())
    scene.addNewObject(cloudCreator.clone());

# for i in range(0,nx):
#     for j in range(0,nz):
#         p2 = p.clone();
#         location.make(i * 0.8 - 2, height, -j * 0.1);
#         p2.setLocation(location);
#         scene.addNewObject(p2);

#############################################################################

vortex = VEE_ObjectFactory_create("vortex")
vortex.setValueFloat("range", 5.0);
vortex.setValueFloat("faderange", 0.1);
vortex.setValueFloat("magnitude", 0.04);
vortex.setValueFloat("epsilon", 0.05);
vortex.setValueFloat("strength", 0.3);
vortex.setValueFloat("maxforce", 0.03);
vortex.setAgeLimit(1000000);
vortex.setVelocityUpdate(0)
vortex.setValueVector3f("axes", 0.0, 1.0, 0.0)
vortex.setLocation3(20.0, height, -7.0)
vortex.setVelocity3(-0.2, 0.0, -0.03)

scene.addNewObject(vortex);

#############################################################################


vortex2 = VEE_ObjectFactory_create("vortex")
vortex2.setValueFloat("range", 1.0);
vortex2.setValueFloat("faderange", 0.1);
vortex2.setValueFloat("magnitude", 0.005);
vortex2.setValueFloat("epsilon", 0.05);
vortex2.setValueFloat("strength", 0.01);
vortex2.setValueFloat("maxforce", 0.02);
vortex2.setAgeLimit(30);
vortex2.setVelocityUpdate(1)
vortex2.setValueVector3f("axes", 0.0, -1.0, 0.0)
vortex2.setVelocity3(-0.2, 0.0, -0.03)

screator = VEE_Emitter(vortex2)
screator.thisown = 0;

v1 = VEE_Vector3()
v2 = VEE_Vector3()
v1.make( -5.0, 0.0, -5.0)
v2.make( 20.0, 0.0, 20.1)

rv = VEE_ValueRandomVector3()

rv.setRanges(v1, v2)

vo = VEE_ValueOperator()
vo.set("addlocation", rv.clone())
screator.appendOperator(vo.clone())

vortexrange = VEE_ValueRandomFloat()
vortexrange.set(1.5, 5.0);
vo.set("range", vortexrange.clone())
screator.appendOperator(vo.clone())

screator.setRate(0.3);
screator.setLocation3(0.0, height, 0.0)

scene.addNewObject(screator)

#############################################################################

wind = VEE_ObjectFactory_create("wind");
scene.addNewObject(wind);
wind.setValueVector3f("direction", -1.0, 0.0, -1.0);
wind.setValueFloat("strength", 0.1);

#damp = VEE_ObjectFactory_create("damping")
#scene.addNewObject(damp)


#############################################################################

paramView = VEE_ValueWindow()

paramView.addFloatParameter("Wind strength", "strength",
                            wind, 0.1, .0, 2.0,
                            VEE_MAP_LINEAR);

paramView.addFloatParameter("Vortex rate", "rate",
                            screator, 0.5, .0, 2.0,
                            VEE_MAP_LINEAR);

paramView.addFloatParameter("Vortex magnitude", "type/magnitude",
                            screator, 0.005, .0001, 0.02,
                            VEE_MAP_LINEAR);



#############################################################################

# Make it visible:

vq = VEE_Qt(scene)
# Make force invisible:
vq.toggleForceMode();
qa.setMainWidget(vq)
vq.show()

vq.setValueFloat("speed", 12.0);
vq.setValueFloat("maxrecursion", 3);
vq.setValueFloat("GL/alphamul", 0.05);
vq.setValueFloat("GL/size", 1.2);
vq.setValueRgbaf("GL/bgcolor", 0.2, 0.2, 0.8, 1.0);
# vq.setValueFloat("GL/fixedfade", 1.0);
# vq.setValueFloat("rate", 10);

vq.setFrameFile("frames/sky-%.5d.jpeg");

gl = vq.renderer();

gl.setCameraPosition3f(0.0, -2.0, 1.0);
gl.setCameraAngles(VEE_PI, VEE_PI * 0.2);

paramView.bangValues()

paramView.show()

print vq.renderer().subTextureCount()

qa.execute()
