# Simple fire effect

# Usual initializations:
from vee_init import *
from vee import *
import math
qa = QApplication_newApp()
scene = VEE_SceneBox()
VEE_ObjectFactory_init()

GEE_Debug_setDebug("GEE_GlRenderer")

ts = TimeStamp()
# Make a path model

pa = GEE_PathInsert()
path = pa.path()

rot = VEE_Matrix3()
rot.identity();

path.addVertex(VEE_Vector3(0.0, 2.0, 0.0), rot);
path.addVertex(VEE_Vector3(0.0, 2.0, 2.0), rot);
path.addVertex(VEE_Vector3(0.0, 3.0, 4.0), rot);
path.addVertex(VEE_Vector3(0.0, 3.0, 5.0), rot);
path.addVertex(VEE_Vector3(1.0, 3.0, 6.0), rot);
path.addVertex(VEE_Vector3(2.0, 4.0, 7.0), rot);

n = 30;
for i in range(0,n):
    path.addVertex(VEE_Vector3(3.0 * math.cos(VEE_TWO_PI * i / n),
                               2 + (i * 2.5) / n ,
                               3.0 * math.sin(VEE_TWO_PI * i / n)), rot)


erasetime = 3.0

group1 = GEE_OperatorGroup()
group1.setScale(0.1);
group1.autoId();

group2 = GEE_OperatorGroup()
ts.setSeconds(erasetime);
group2.setOffset(ts);
group2.setScale(0.0);
group2.autoId();

pa2 = GEE_PathInsert()
path2 = pa2.path()
# One of the preceding control points:
path2.addVertex(VEE_Vector3(0.0, 4.0, 7.0), rot); 
path2.addVertex(VEE_Vector3(0.0, 7.0, 7.0), rot); 

profile = GEE_Profile()
#profile.generateCircle(0.4, 12);
profile.generateBar(0.4, 0.3);
# profile.getVertex(2).m_continues = 0;
#profile.getVertex(4).m_continues = 0;
#profile.getVertex(6).m_continues = 0;

#############################################################################

lines1 = GEE_Lines3D()
lines1.addVertex(0, 0, 0);
lines1.addVertex(1, 0, 0);
lines1.addVertex(2, 1, 0);
lines1.thisown = 0

lines2 = GEE_Lines3D()
lines2.addVertex(0, 1, 0);
lines2.addVertex(-1, 1, 0);
lines2.addVertex(-2, 2, 0);
lines2.thisown = 0

group = GEE_Group()
group.thisown = 0

#############################################################################

# Make it visible:

vq = VEE_Qt(scene)
engine = vq.getGlWidget().geeEngine()
engine.actions().addOperatorGroup(group1);
engine.actions().addOperatorGroup(group2);
world = engine.world()

world.addGeometry(lines1)
world.addGeometry(lines2)
world.addGeometry(group)
group.addChild(lines1.id())
group.addChild(lines2.id())

# Configure GEE engine.
pathId = GEE_IdContainer_allocateId();
pa.setPathId(pathId)
engine.addOperator(pa)

pathId2 = GEE_IdContainer_allocateId();
pa2.setPathId(pathId2)
engine.addOperator(pa2)

meshId = GEE_IdContainer_allocateId();

mat = GEE_Material()
mat.setTwoSided(1)

#apm = GEE_PathToMesh(pathId, meshId)
#apm.setProfile(profile);
#apm.setMaterial(mat);
apm = GEE_PathToLines(pathId, meshId)
#apm = GEE_PathToParticles(pathId, meshId)

apm.setGroup(group1.id());

# eraser = GEE_EraseAroundPath(pathId2)
# eraser = GEE_ColorAroundPath(pathId2)
eraser = GEE_MoveAroundPath(pathId2, meshId)
# eraser = GEE_MoveAroundPath(pathId2)

eraser.setGroup(group2.id());

eraser.setRadius(3.0);

profile.thisown = 0;
pa.thisown = 0;
pa2.thisown = 0;
apm.thisown = 0;
eraser.thisown = 0;

ts.setSeconds(path.endTime() + 0.5)
apm.interval().setEnd(ts)

eraser.interval().setEnd(ts)
ts.setSeconds(erasetime);
eraser.interval().setBegin(ts)

ids = GEE_IdSelect()
ids.addId(meshId);
ids.thisown = 0;

vq.getGlWidget().geeEngine().actions().addOperator(apm)
vq.getGlWidget().geeEngine().actions().addOperator(eraser)
# vq.getGlWidget().geeEngine().actions().addOperator(ids)
vq.getGlWidget().geeMaterials().defaultMaterial().setUseVertexColors(1)
# vq.getGlWidget().geeEngine().undo();

# Make forces invisible:
vq.toggleForceMode();
qa.setMainWidget(vq)
vq.show()

vq.setFrameFile("frames/fire-%.5d.jpg")


print vq.renderer().subTextureCount()

qa.execute()

vq.getGlWidget().geeEngine().write("wonder.gee");
