
# First we need to add the path of the dynamnic library to the search
# path:

from vee_init import *
from vee import *

v = VEE_Vector3()
v.clear()
v.make(0.15, 0.25, 0.95)

b = VEE_Vector3()
b.make(0.11, 0.21, 0.31)

c = b + v

print v.y
print c.z

c.set(0, 678.9)

print c.x

vf = VEE_ValueFloat()
vf.setValue(123.4)

print vf.getValue()


vv3 = VEE_ValueVector3()

vv3.setValue(c)
tmpv = vv3.getValue()
print tmpv.x
print tmpv.thisown
vv3clone = vv3.clone()
print vv3clone.thisown

cc3cloneCasted = VEE_ValueVector3_cast(vv3clone)

VEE_ObjectFactory_init()


p1 = VEE_ObjectFactory_create("particle")
x = VEE_ObjectFactory_create("FOO")


qa = QApplication_newApp()

print qa

box = VEE_SceneBox()

p = VEE_Particle()
p.setAgeLimit(3.0)
creator =  VEE_Emitter(p)

rgbatable = VEE_RgbaTable()
color = VEE_Rgba()

color.set(1.0, 0.0, 0.0, 1.0)
rgbatable.appendColor(color)
color.set(0.0, 1.0, 0.0, 1.0)
rgbatable.appendColor(color)
color.set(0.0, 0.0, 1.0, 1.0)
rgbatable.appendColor(color)

looks = VEE_LooksColorTable(rgbatable)

valueLooks = VEE_ValueLooks()
valueLooks.setLooks(looks)

r = p.setValue("looks", valueLooks)

rv = VEE_ValueRandomVector3()
vo = VEE_ValueOperator()

vo.set("addvelocity", rv.clone())

creator.appendOperator(vo.clone())

vo.set("addlocation", rv.clone())
creator.appendOperator(vo.clone())

rf = VEE_ValueRandomFloat()
rf.set(0.5, 1.0)

vo.set("mass", rf.clone())
creator.appendOperator(vo.clone())

box.addNewObject(creator)

VEE_ObjectFactory_init()
g = VEE_ObjectFactory_create("gravity")

forceg = VEE_ForceObject_cast(g)

#if forceg != None:
#    box.addNewForce(forceg)

box.addNewObject(g)

vq = VEE_QT(box)
qa.setMainWidget(vq)
vq.show()

paramView = VEE_ValueWindow()

gravityParam = VEE_ParameterFloat()
gravityParam.set(-9.81, -20.0, 20.0)
gravityParam.setName("gravity")
paramView.addParameter(gravityParam, g);

rateParam = VEE_ParameterFloat()
rateParam.set(50.0, 1.0, 2000.0)
rateParam.setName("rate")
rateParam.setMapping(VEE_MAP_LOGARITHMIC)
paramView.addParameter(rateParam, creator);

splitParam = VEE_ParameterFloat()
splitParam.set(100, 5, 10000)
splitParam.setMapping(VEE_MAP_LOGARITHMIC)
splitParam.setName("splitat")
paramView.addParameter(splitParam, vq);

splitParam = VEE_ParameterFloat()
splitParam.set(50, 5, 10000)
splitParam.setMapping(VEE_MAP_LOGARITHMIC)
splitParam.setName("collapseat")
paramView.addParameter(splitParam, vq);

paramView.show()

qa.execute()

