# Usual initializations:
from vee_init import *
from vee import *
import math
qa = QApplication_newApp()
scene = VEE_SceneBox()
VEE_ObjectFactory_init()
GEE_World_loadTextureDefinitions("vee-gl.config");

agelimit = 2.0
gravity = 5.0

ts = TimeStamp()

vq = VEE_Qt(scene)
engine = vq.getGlWidget().geeEngine()
world = engine.world()

# Make a path model

path = GEE_Path3D()
path.thisown = 0;

rot = VEE_Matrix3()
rot.identity();

print rot

path.addVertex(VEE_Vector3(0.0, 2.0, 0.0), rot);
path.addVertex(VEE_Vector3(0.0, 2.0, 2.0), rot);
path.addVertex(VEE_Vector3(0.0, 3.0, 4.0), rot);
path.addVertex(VEE_Vector3(0.0, 3.0, 5.0), rot);
path.addVertex(VEE_Vector3(1.0, 3.0, 6.0), rot);
path.addVertex(VEE_Vector3(2.0, 4.0, 7.0), rot);

n = 30;
for i in range(0,n):
    path.addVertex(VEE_Vector3(3.0 * math.cos(VEE_TWO_PI * i / n),
                               2 + (i * 2.5) / n ,
                               3.0 * math.sin(VEE_TWO_PI * i / n)), rot)

# Insert the path into the world:

world.addGeometry(path);

# Now create a flat square mesh:

mesh = GEE_TriangleMesh()
mesh.thisown = 0;

mesh.createRectangularGrid(5, 5)

vid = 14

v = mesh.getVertex(vid);
v.m_location.z = -1.2
# v.m_location.x += 0.5

for i in range(0, 10):
    v.m_location = mesh.smoothVertex(vid, 0.5);

mesh.autoNormalize()

world.addGeometry(mesh);

# Take a snapshot of the world into the gallery:

galId = engine.gallery().takeSnapshot(world)

# Clean up the world:

world.clear();

# Make an operator that copies the gallery item into the world:

cg = GEE_CopyGeometry(galId, 0);
cg.thisown = 0;

ts = TimeStamp()
ts.setSeconds(2.0);

cg.interval().set(ts);

# Rotate the object:
m = VEE_Matrix4d()
m.identity()

r = VEE_Matrix3d()
r.identity()
r.rotateZ(VEE_PI * 0.3);
m.setRotation(r);

cg.setTransformation(m);

engine.actions().addOperator(cg);

# Make forces invisible:
vq.toggleForceMode();
qa.setMainWidget(vq)
vq.show()

vq.setFrameFile("frames/fire-%.5d.jpg")

print vq.renderer().subTextureCount()

qa.execute()

vq.getGlWidget().geeEngine().write("wonder.gee");
