/* COPYRIGHT
 *
 * This file is part of the Simple Object Loader and Renderer - SOLAR
 *
 * Read the file "SOLAR-LICENSE" for the license.
 *
 * Authors & Copyright:
 *
 * Tommi Ilmonen, 2001-2003, except LWO-code by RJ, 2001-2003
 *
 * Tommi's email: firstname.lastname@hut.fi
 *
 */

#ifndef SOLAR_ERROR_H
#define SOLAR_ERROR_H

// #include <vee_config.h>


namespace Solar {


extern void trace(const char *msg, ...);
extern void error(const char *msg, ...);
extern void fatal(const char *msg, ...);

#ifdef FAST

#define SOLAR_TRACE(x) 
#define SOLAR_ERROR(x) 
#define SOLAR_FATAL(x) 

#else

#define SOLAR_TRACE(x) trace(x)
#define SOLAR_ERROR(x) error(x)
#define SOLAR_FATAL(x) fatal(x)

#endif

} // namespace Solar


#endif
